/*
 * Newt-Puzzle
 * Copyright (C) Aude Jaulent 2009 <elderme@tuxfamily.org>
 * 
 * Newt-Puzzle is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Newt-Puzzle is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _RECTANGLEPRISM_H_
#define _RECTANGLEPRISM_H_

#include "../newtEngine/entity.h"
#include "../newtEngine/mesh.h"
#include "prism.h"


class RectanglePrismMesh: public Mesh 
{
public:
	RectanglePrismMesh(float dim1, int nb1, float dim2, int nb2, float height, int nbH, float edgeRadius, int nbR,
						 baseType base1, baseType base2, bool inside);

	~RectanglePrismMesh();		

	void initFirstParams();				
		
	void createVertices(Vector3 *ptr);
	void createColors(Color *ptr);
	void createNormals(Vector3 *ptr);
	void createTexCoords(GLfloat *ptr);
	void createFogCoords(GLfloat *ptr);
	void createTangents(Vector3 *ptr);			
	
	void createIndices(int numArray, GLuint *ptr);		

		
		
protected:
	float mHeight, mDim1, mDim2, mEdgeRadius;
	int mNbH, mNb1, mNb2, mNbR;
	bool mInside;		
	baseType mBase1, mBase2;
};

#endif // _RECTANGLEPRISM_H_
